/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Peter Wilson, orignal author.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
XaLib.include("chrome://xalib/content/RDF/RDF.js");


function ProxyDataSource
/** A datasource with a JS wrapper. 
* WARNING: This class should not be modified.
* This class serves as a base class for a datasource which wraps another data source to provide
* additional function. 
* Usage:
* 1. Add the following in the YourDataSource constructor function
* 	YourDataSource.prototype = new WrappedDataSource();
* 2. Override any of the methods below to add additional functionality.
* E.g. DirSortedDataSource
* This adds some deduced resources and relations for a FileSystem data source which
* enable XUL template sorting in the expected order: DIR names... then FILE names...
*/
(
	dataSource //nsIRDFDataSource: The dataSource to be wrapped.
)
{
  this.dataSource = dataSource;
  this.URI = this.dataSource.URI;
}

ProxyDataSource.prototype.GetSource = function(pred, obj, tv) {
	 return this.dataSource.GetSource(pred, obj, tv);
}

ProxyDataSource.prototype.GetSources = function(pred, obj, tv) {
	 return this.dataSource.GetSources(pred, obj, tv);
}

ProxyDataSource.prototype.GetTarget = function(subj, pred, tv) {
	 return this.dataSource.GetTarget(subj, pred, tv);
}

ProxyDataSource.prototype.GetTargets = function(subj, pred, tv) {
	 return this.dataSource.GetTargets(subj, pred, tv);
}

ProxyDataSource.prototype.Assert = function(subj, pred, obj, tv) {
	 return this.dataSource.Assert(subj, pred, obj, tv);
}

ProxyDataSource.prototype.Unassert = function(subj, pred, obj, tv) {
	 return this.dataSource.Unassert(subj, pred, obj, tv);}

ProxyDataSource.prototype.Change = function(subj, pred, oldobj, newobj) {
	 return this.dataSource.Change(subj, pred, oldobj, newobj);}
}

ProxyDataSource.prototype.Move = function(oldsubj, newsubj, pred, obj)  {
	throw this.dataSource.Move(oldsubj, newsubj, pred, obj); 
}

ProxyDataSource.prototype.HasAssertion = function(subj, pred, obj, tv) {
	return this.dataSource.HasAssertion(subj, pred, obj, tv);
}

ProxyDataSource.prototype.AddObserver = function(aObserver) {
	 this.dataSource.AddObserver(aObserver);
}

ProxyDataSource.prototype.RemoveObserver = function(aObserver) {
	 this.dataSource.RemoveObserver(aObserver);
}

ProxyDataSource.prototype.ArcLabelsIn = function(obj) {
	return this.dataSource.ArcLabelsIn(obj);
}

ProxyDataSource.prototype.ArcLabelsOut = function(subj) {
	return this.dataSource.ArcLabelsOut(obj);
}

ProxyDataSource.prototype.GetAllResources = function() {
	return this.dataSource.GetAllResources();
}

ProxyDataSource.prototype.hasArcIn = function(obj, pred) {
	return this.dataSource.hasArcIn(obj, pred);
}

ProxyDataSource.prototype.hasArcOut = function(subj, pred) {
	return this.dataSource.hasArcOut(subj, pred);
}



