/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XulApp IDE.
 *
 * The Initial Developer of the Original Code is Synesis Software (USA) Inc.
 *

 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * Synesis Software (USA) Inc. the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * 	Author: Peter Wilson.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the LGPL or the GPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 *
 * ***** END LICENSE BLOCK ***** */
 
 /* Notes:
 * Variables or methods prefixed by underscore are for internal use only.
 */
 
 
 // Add some of the usual string handling functions
 String.prototype.startsWith = function (prefix) {
 	if (typeof(prefix) != "string")
 		return false;
	var prefixLength = prefix.length;	
 	if (this.length < prefixLength)
 		return false;
 	return (this.substr(0, prefixLength) == prefix);	
 }
 String.prototype.endsWith = function (suffix) {
  	if (typeof(suffix) != "string")
  		return false;
 	var suffixLength = suffix.length;
 	var thisLength = this.length;
  	if (thisLength < suffixLength)
  		return false;
  	return (this.substr(thisLength - suffixLength, suffixLength) == suffix);	
 }
String.prototype.hash = function() {
    var i = this.length;
	if (!i)
		return aConst;
    var hash = 0;
    do {
    	if (hash > 9999999999999) // Maximum number represented as an integer.
    		hash = hash % 751229437; // some arbitrary divisor to stop the hash getting too large.
	    hash = 31*hash + this.charCodeAt(--i);
    } while(i);
    return (hash<0)?-hash:hash;
}
 
